<?php
class ControllerExtensionModuleForcedLogin extends Controller {
	private $error = array();

    public function install() {

        $this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "forced_login` (
            `forced_login_id` int(11) NOT NULL AUTO_INCREMENT,
            `store_id` int(11) NOT NULL,
            `route` varchar(250) NOT NULL,
            PRIMARY KEY (`forced_login_id`),
            KEY `forced_login_id` (`forced_login_id`)
            ) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1");
        
        $this->load->model('setting/setting');
        $data['module_forced_login_status'] = 1;
		$this->model_setting_setting->editSetting('module_forced_login', $data);
    }
    
    public function uninstall() {
        
        $this->load->model('setting/setting');
		$this->model_setting_setting->deleteSetting('module_forced_login');
            
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "forced_login`");
    }
    

	public function index() {
		$this->load->language('extension/module/forced_login');

		$this->document->setTitle($this->language->get('heading_title_m'));

		$this->load->model('extension/module/forced_login');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_extension_module_forced_login->addForcedLogin($this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true));
            
		}

		$data['heading_title'] = $this->language->get('heading_title_m');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_default'] = $this->language->get('text_default');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');

		$data['entry_store'] = $this->language->get('entry_store');
        $data['entry_route'] = $this->language->get('entry_route');


		$data['button_add'] = $this->language->get('button_add');
        $data['button_remove'] = $this->language->get('button_remove');
        $data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title_m'),
			'href' => $this->url->link('extension/module/forced_login', 'token=' . $this->session->data['token'], true)
		);

		$data['action'] = $this->url->link('extension/module/forced_login', 'token=' . $this->session->data['token'], true);
		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'], true);

        $this->load->model('setting/store');
		$data['stores'] = $this->model_setting_store->getStores();
        
       
        $data['forced_logins'] = array(); 
           
        if (isset($this->request->post['forced_login'])) {
			$data['forced_logins'] = $this->request->post['forced_login'];
		} else {
			$data['forced_logins'] = $this->model_extension_module_forced_login->getForcedLogin();
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/forced_login', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/forced_login')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}
}