<?php
class ControllerExtensionModuleOrderInfo extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/order_info');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('order_info', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true));
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] 			= $this->language->get('text_edit');
		$data['text_enabled'] 		= $this->language->get('text_enabled');
		$data['text_disabled'] 		= $this->language->get('text_disabled');

		$data['entry_status'] 		= $this->language->get('entry_status');
		$data['entry_success_page'] = $this->language->get('entry_success_page');
		$data['entry_confirm_page'] = $this->language->get('entry_confirm_page');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/order_info', 'token=' . $this->session->data['token'], true)
		);

		$data['action'] = $this->url->link('extension/module/order_info', 'token=' . $this->session->data['token'], true);

		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true);

		if (isset($this->request->post['order_info_status'])) {
			$data['order_info_status'] = $this->request->post['order_info_status'];
		} else {
			$data['order_info_status'] = $this->config->get('order_info_status');
		}

		if (isset($this->request->post['order_info_success_page'])) {
			$data['order_info_success_page'] = $this->request->post['order_info_success_page'];
		} else {
			$data['order_info_success_page'] = $this->config->get('order_info_success_page');
		}

		if (isset($this->request->post['order_info_confirm_page'])) {
			$data['order_info_confirm_page'] = $this->request->post['order_info_confirm_page'];
		} else {
			$data['order_info_confirm_page'] = $this->config->get('order_info_confirm_page');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/order_info', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/order_info')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}
}