<?php
class ControllerExtensionModulepmbycust extends Controller { 	
	private $error = array();
	private $modpath = 'module/pmbycust'; 
	private $modtpl = 'module/pmbycust.tpl';
	private $modformtpl = 'module/pmbycustform.tpl';
	private $modpopformtpl = 'module/pmbycust_popform.tpl'; 	
	private $modname = 'pmbycust';
	private $modtext = 'Payment Method By Customer';
	private $modid = '32369';
	private $modssl = 'SSL';
	private $modemail = 'opencarttools@gmail.com';
	private $token_str = '';
	private $modurl = 'extension/module';
	private $modurltext = '';

	public function __construct($registry) {
		parent::__construct($registry);
 		
		if(substr(VERSION,0,3)>='3.0' || substr(VERSION,0,3)=='2.3') { 
			$this->modpath = 'extension/module/pmbycust';
 			$this->modtpl = 'extension/module/pmbycust';
			$this->modformtpl = 'extension/module/pmbycustform';
 			$this->modpopformtpl = 'extension/module/pmbycust_popform'; 	
		} else if(substr(VERSION,0,3)=='2.2') {
			$this->modtpl = 'module/pmbycust';
			$this->modformtpl = 'module/pmbycustform';
			$this->modpopformtpl = 'module/pmbycust_popform'; 	
		} 
		
		if(substr(VERSION,0,3)>='3.0') { 
			$this->modname = 'module_pmbycust';
			$this->modurl = 'marketplace/extension'; 
			$this->token_str = 'user_token=' . $this->session->data['user_token'] . '&type=module';
		} else if(substr(VERSION,0,3)=='2.3') {
			$this->modurl = 'extension/extension';
			$this->token_str = 'token=' . $this->session->data['token'] . '&type=module';
		} else {
			$this->token_str = 'token=' . $this->session->data['token'];
		}
		
		if(substr(VERSION,0,3)>='3.0' || substr(VERSION,0,3)=='2.3' || substr(VERSION,0,3)=='2.2') { 
			$this->modssl = true;
		} 
 	} 
	
	public function index() {
		$data = $this->load->language($this->modpath);
		$this->modurltext = $this->language->get('text_extension');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting($this->modname, $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			if(! (isset($this->request->post['svsty']) && $this->request->post['svsty'] == 1)) {
				$this->response->redirect($this->url->link($this->modurl, $this->token_str, $this->modssl));
			}
		}

		$data['heading_title'] = $this->language->get('heading_title');
 		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
 		$data['entry_status'] = $this->language->get('entry_status');
  		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', $this->token_str, $this->modssl)
		);
		
		$data['breadcrumbs'][] = array(
			'text' => $this->modurltext,
			'href' => $this->url->link($this->modurl, $this->token_str, $this->modssl)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link($this->modpath, $this->token_str, $this->modssl)
		);

		$data['action'] = $this->url->link($this->modpath, $this->token_str, $this->modssl);
		
		$data['cancel'] = $this->url->link($this->modurl, $this->token_str , $this->modssl); 
		
		if(substr(VERSION,0,3)>='3.0') { 
			$data['user_token'] = $this->session->data['user_token'];
		} else {
			$data['token'] = $this->session->data['token'];
		}

		$data[$this->modname.'_status'] = $this->setvalue($this->modname.'_status');
		
 		$data['modname'] = $this->modname;
		$data['modemail'] = $this->modemail;
  		  
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view($this->modtpl, $data));
	}
	
	protected function setvalue($postfield) {
		if (isset($this->request->post[$postfield])) {
			$postfield_value = $this->request->post[$postfield];
		} else {
			$postfield_value = $this->config->get($postfield);
		} 	
 		return $postfield_value;
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', $this->modpath)) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}
	
	public function popform() {
		$data[$this->modname.'_status'] = $this->setvalue($this->modname.'_status');
		if($data[$this->modname.'_status']) { 
			$data = $this->load->language($this->modpath); 
			$data['modpath'] = $this->modpath;
			
			$data['action'] = $this->url->link($this->modpath.'/masseditpost', $this->token_str, $this->modssl);
			
			if(substr(VERSION,0,3)>='3.0') { 
				$data['user_token'] = $this->session->data['user_token'];
			} else {
				$data['token'] = $this->session->data['token'];
			}
			
 			$data['payment_method'] = $this->getPM(); 
			
 			return $this->load->view($this->modpopformtpl, $data);
		}
	}
 	
	public function masseditpost() {
 		$data = $this->load->language($this->modpath); 
		//echo "<pre>";print_r($this->request->post);exit;
 		$recordid_arr = array();
		if($this->request->post['recordid']) {
			$recordid_arr = explode(",",$this->request->post['recordid']);
		} 
		
		if($recordid_arr) {
			foreach($recordid_arr as $recid) {
				$this->savepmbycustform($recid);
			}
		}
		$json['msg'] = $data['text_save_success'];
		$json['redirect'] = true;
		//echo json_encode($json);
		
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
 	}
	
	public function savepmbycustform($customer_id) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "pmbycust WHERE customer_id = '" . (int)$customer_id . "'");
		
		foreach ($this->request->post['customer_pmbycust'] as $key => $setting) {
 			$this->db->query("INSERT INTO " . DB_PREFIX . "pmbycust SET customer_id = '" . (int)$customer_id . "', `row` = '" . $this->db->escape($key) . "', `setting` = '" . $this->db->escape(json_encode($setting, true)) . "' ");
 		}
	}
	
	public function getform() {
 		$data[$this->modname.'_status'] = $this->setvalue($this->modname.'_status');
		if($data[$this->modname.'_status']) { 
			$this->load->language($this->modpath);
			
			$data['entry_pm'] = $this->language->get('entry_pm'); 
			
			$data['payment_method'] = $this->getPM(); 
  
 			if (isset($this->request->post['customer_pmbycust'])) {
				$data['customer_pmbycust'] = $this->request->post['customer_pmbycust'];
			} elseif (isset($this->request->get['customer_id'])) {
				$data['customer_pmbycust'] = $this->getpmbycustdata($this->request->get['customer_id']);
			} else {
				$data['customer_pmbycust'] = array();
			}
			
			return $this->load->view($this->modformtpl, $data);
		} 		
	}
	
	public function getpmbycustdata($customer_id) {
		$customer_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "pmbycust WHERE customer_id = '" . (int)$customer_id . "' order by row");

		foreach ($query->rows as $result) {
 			$customer_data[$result['row']] = json_decode($result['setting'], true);
		}

		return $customer_data;
	}
	
	public function getpm() {
		$pm = array();
		if(substr(VERSION,0,3)>='3.0') { 
			$this->load->model('setting/extension');
			$extensions = $this->model_setting_extension->getInstalled('payment');
		} else {
			$this->load->model('extension/extension');
			$extensions = $this->model_extension_extension->getInstalled('payment');
		}		
		
		if(substr(VERSION,0,3)>='3.0' || substr(VERSION,0,3)=='2.3') {
			$files = glob(DIR_APPLICATION . 'controller/extension/payment/*.php', GLOB_BRACE);
		} else {
			$files = glob(DIR_APPLICATION . 'controller/payment/*.php', GLOB_BRACE);
		}
		
		if ($files) {
			foreach ($files as $file) {
				$extension = basename($file, '.php'); 
				$extension_name = basename($file, '.php'); 
				if(substr(VERSION,0,3)>='3.0') { 					
					$extension_name = 'payment_'.$extension;
				}				
				if($this->config->get($extension_name . '_status')) {
					if(substr(VERSION,0,3)>='3.0' || substr(VERSION,0,3)=='2.3') {
						$lang = $this->load->language('extension/payment/' . $extension);
					} else {
						$lang = $this->load->language('payment/' . $extension);
					}
					$pm[] = array("key" => $extension_name, "val" => $lang['heading_title']);
				}
			}
		}
		return $pm;
	}
	
	public function install() {
		$query = $this->db->query("SHOW TABLES LIKE '".DB_PREFIX."pmbycust' ");
		if(!$query->num_rows){
			$this->db->query("CREATE TABLE IF NOT EXISTS `".DB_PREFIX."pmbycust` (
			  `pmbycust_id` int(11) NOT NULL AUTO_INCREMENT,
 			  `customer_id` int(11) NOT NULL DEFAULT '0',
			  `row` int(5) NOT NULL,
			  `setting` TEXT, 		  
  			  PRIMARY KEY (`pmbycust_id`)
			  ) ENGINE=MyISAM  DEFAULT CHARSET=utf8");
		}
		
		if(function_exists('curl_version')) { 
			$pdata['extid'] = $this->modid;
			$pdata['version'] = VERSION;
			$pdata['installat'] = HTTP_CATALOG;
			$pdata['email'] = $this->config->get('config_email'); 
			
 			$curl = curl_init("http://www.opencarttools.net/licentry.php");
	
 			curl_setopt($curl, CURLOPT_HEADER, 0);
 			curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
			curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
			curl_setopt($curl, CURLOPT_POST, 1);
			curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 10);
			curl_setopt($curl, CURLOPT_TIMEOUT, 10);
			curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($pdata, '', '&'));
	
			$response = curl_exec($curl); 
			
			//echo $response; exit;
		}      
	}
	public function uninstall() { 
		$this->db->query("DROP TABLE `".DB_PREFIX."pmbycust` ");
		
		// uninstalled        
	} 	 
}