<?php
class ControllerToolSalesagent extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('tool/salesagent');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('tool/salesagent');
		$this->model_tool_salesagent->createTable();
		$this->getList();
	}

	public function add() {
		$this->load->language('tool/salesagent');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('tool/salesagent');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->model_tool_salesagent->addsalesagent($this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['filter_name'])) {
				$url .= '&filter_name=' . urlencode(html_entity_decode($this->request->get['filter_name'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset($this->request->get['filter_email'])) {
				$url .= '&filter_email=' . urlencode(html_entity_decode($this->request->get['filter_email'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset($this->request->get['filter_status'])) {
				$url .= '&filter_status=' . $this->request->get['filter_status'];
			}

			if (isset($this->request->get['filter_date_added'])) {
				$url .= '&filter_date_added=' . $this->request->get['filter_date_added'];
			}

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('tool/salesagent', 'token=' . $this->session->data['token'] . $url, 'SSL'));
		}

		$this->getForm();
	}

	public function edit() {
		$this->load->language('tool/salesagent');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('tool/salesagent');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->model_tool_salesagent->editsalesagent($this->request->get['salesagent_id'], $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['filter_name'])) {
				$url .= '&filter_name=' . urlencode(html_entity_decode($this->request->get['filter_name'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset($this->request->get['filter_email'])) {
				$url .= '&filter_email=' . urlencode(html_entity_decode($this->request->get['filter_email'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset($this->request->get['filter_status'])) {
				$url .= '&filter_status=' . $this->request->get['filter_status'];
			}

			if (isset($this->request->get['filter_date_added'])) {
				$url .= '&filter_date_added=' . $this->request->get['filter_date_added'];
			}

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('tool/salesagent', 'token=' . $this->session->data['token'] . $url, 'SSL'));
		}

		$this->getForm();
	}

	public function delete() {
		$this->load->language('tool/salesagent');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('tool/salesagent');

		if (isset($this->request->post['selected']) && $this->validateDelete()) {
			foreach ($this->request->post['selected'] as $salesagent_id) {
				$this->model_tool_salesagent->deletesalesagent($salesagent_id);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['filter_name'])) {
				$url .= '&filter_name=' . urlencode(html_entity_decode($this->request->get['filter_name'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset($this->request->get['filter_email'])) {
				$url .= '&filter_email=' . urlencode(html_entity_decode($this->request->get['filter_email'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset($this->request->get['filter_status'])) {
				$url .= '&filter_status=' . $this->request->get['filter_status'];
			}

			if (isset($this->request->get['filter_date_added'])) {
				$url .= '&filter_date_added=' . $this->request->get['filter_date_added'];
			}

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('tool/salesagent', 'token=' . $this->session->data['token'] . $url, 'SSL'));
		}

		$this->getList();
	}

	protected function getList() {
		if (isset($this->request->get['filter_name'])) {
			$filter_name = $this->request->get['filter_name'];
		} else {
			$filter_name = null;
		}

		if (isset($this->request->get['filter_email'])) {
			$filter_email = $this->request->get['filter_email'];
		} else {
			$filter_email = null;
		}

		if (isset($this->request->get['filter_date_added'])) {
			$filter_date_added = $this->request->get['filter_date_added'];
		} else {
			$filter_date_added = null;
		}

		if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
			$sort = 'firstname';
		}

		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset($this->request->get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode($this->request->get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['filter_email'])) {
			$url .= '&filter_email=' . urlencode(html_entity_decode($this->request->get['filter_email'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['filter_date_added'])) {
			$url .= '&filter_date_added=' . $this->request->get['filter_date_added'];
		}

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('tool/salesagent', 'token=' . $this->session->data['token'] . $url, 'SSL')
		);

		$data['add'] = $this->url->link('tool/salesagent/add', 'token=' . $this->session->data['token'] . $url, 'SSL');
		$data['delete'] = $this->url->link('tool/salesagent/delete', 'token=' . $this->session->data['token'] . $url, 'SSL');
		$data['report'] = $this->url->link('report/salesagent', 'token=' . $this->session->data['token'] . $url, 'SSL');
		$data['salesagentreportct'] = $this->url->link('report/salesagentct', 'token=' . $this->session->data['token'], 'SSL');
		$data['clist'] = $this->url->link('tool/salesagentclist', 'token=' . $this->session->data['token'] . $url, 'SSL');
		
		$data['salesagents'] = array();

		$filter_data = array(
			'filter_name'              => $filter_name,
			'filter_email'             => $filter_email,
			'filter_date_added'        => $filter_date_added,
			'sort'                     => $sort,
			'order'                    => $order,
			'start'                    => ($page - 1) * $this->config->get('config_limit_admin'),
			'limit'                    => $this->config->get('config_limit_admin')
		);

		$salesagent_total = $this->model_tool_salesagent->getTotalsalesagents($filter_data);
		
		$results = $this->model_tool_salesagent->getsalesagents($filter_data);
		
		foreach ($results as $result) {

			$data['salesagents'][] = array(
				'salesagent_id'    => $result['salesagent_id'],
				'name'           => $result['firstname']." ".$result['lastname'],
				'email'          => $result['email'],
				'status'         => ($result['status'] ? $this->language->get('text_enabled') : $this->language->get('text_disabled')),
				'date_added'     => date($this->language->get('date_format_short'), strtotime($result['date_added'])),
				'edit'           => $this->url->link('tool/salesagent/edit', 'token=' . $this->session->data['token'] . '&salesagent_id=' . $result['salesagent_id'] . $url, 'SSL')
			);
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_list'] = $this->language->get('text_list');
		$data['text_tip1'] = $this->language->get('text_tip1');
		$data['text_clist'] = $this->language->get('text_clist');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');
		$data['text_default'] = $this->language->get('text_default');
		$data['text_no_results'] = $this->language->get('text_no_results');
		$data['text_confirm'] = $this->language->get('text_confirm');
		$data['text_subtotal'] = $this->language->get('text_subtotal');
		$data['text_total'] = $this->language->get('text_total');
		$data['text_settings'] = $this->language->get('text_settings');
		$data['text_clist'] = $this->language->get('text_clist');
		$data['text_salesagentreport'] = $this->language->get('text_salesagentreport');
		$data['text_salesagentreportct'] = $this->language->get('text_salesagentreportct');
		$data['text_salesagent_register'] = $this->language->get('text_salesagent_register');
		$data['text_salesagent_checkout'] = $this->language->get('text_salesagent_checkout');
		$data['text_salesagent_backend_checkout'] = $this->language->get('text_salesagent_backend_checkout');
		$data['text_salesagent_orderhistory'] = $this->language->get('text_salesagent_orderhistory');
		$data['text_salesagent_commissiontotal'] = $this->language->get('text_salesagent_commissiontotal');
		$data['text_salesagent_coupondiscount'] = $this->language->get('text_salesagent_coupondiscount');
		$data['text_salesagent_recurrsive'] = $this->language->get('text_salesagent_recurrsive');
		$data['text_salesagent_customershow'] = $this->language->get('text_salesagent_customershow');
		

		$data['column_name'] = $this->language->get('column_name');
		$data['column_email'] = $this->language->get('column_email');
		$data['column_status'] = $this->language->get('column_status');
		$data['column_date_added'] = $this->language->get('column_date_added');
		$data['column_action'] = $this->language->get('column_action');

		$data['entry_firstname'] = $this->language->get('entry_firstname');
		$data['entry_email'] = $this->language->get('entry_email');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_date_added'] = $this->language->get('entry_date_added');

		$data['button_approve'] = $this->language->get('button_approve');
		$data['button_add'] = $this->language->get('button_add');
		$data['button_edit'] = $this->language->get('button_edit');
		$data['button_delete'] = $this->language->get('button_delete');
		$data['button_filter'] = $this->language->get('button_filter');
		$data['button_login'] = $this->language->get('button_login');
		$data['button_unlock'] = $this->language->get('button_unlock');

		$data['text_howitworks'] = $this->language->get('text_howitworks');
		$data['text_howitworks_list_content'] = $this->language->get('text_howitworks_list_content');

		$data['token'] = $this->session->data['token'];

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset($this->request->post['selected'])) {
			$data['selected'] = (array)$this->request->post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if (isset($this->request->get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode($this->request->get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['filter_email'])) {
			$url .= '&filter_email=' . urlencode(html_entity_decode($this->request->get['filter_email'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['filter_date_added'])) {
			$url .= '&filter_date_added=' . $this->request->get['filter_date_added'];
		}

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['sort_name'] = $this->url->link('tool/salesagent', 'token=' . $this->session->data['token'] . '&sort=name' . $url, 'SSL');
		$data['sort_email'] = $this->url->link('tool/salesagent', 'token=' . $this->session->data['token'] . '&sort=c.email' . $url, 'SSL');
		$data['sort_date_added'] = $this->url->link('tool/salesagent', 'token=' . $this->session->data['token'] . '&sort=c.date_added' . $url, 'SSL');

		$url = '';

		if (isset($this->request->get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode($this->request->get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['filter_email'])) {
			$url .= '&filter_email=' . urlencode(html_entity_decode($this->request->get['filter_email'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['filter_date_added'])) {
			$url .= '&filter_date_added=' . $this->request->get['filter_date_added'];
		}

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		$pagination = new Pagination();
		$pagination->total = $salesagent_total;
		$pagination->page = $page;
		$pagination->limit = $this->config->get('config_limit_admin');
		$pagination->url = $this->url->link('tool/salesagent', 'token=' . $this->session->data['token'] . $url . '&page={page}', 'SSL');

		$data['pagination'] = $pagination->render();

		$data['results'] = sprintf($this->language->get('text_pagination'), ($salesagent_total) ? (($page - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($page - 1) * $this->config->get('config_limit_admin')) > ($salesagent_total - $this->config->get('config_limit_admin'))) ? $salesagent_total : ((($page - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $salesagent_total, ceil($salesagent_total / $this->config->get('config_limit_admin')));

		$data['filter_name'] = $filter_name;
		$data['filter_email'] = $filter_email;
		$data['filter_date_added'] = $filter_date_added;

		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['licensed_md5'] = $data['licensed'] = ""; 
     if(!$this->config->get("salesagnt_license")){
       // Edit these next three lines to suit your setup and extension ID
        $data['oc_licensing_home'] = 'https://www.cartbinder.com/store/'; // Important to have trailing slash at the end of the SSL URL!
        $data['extension_id'] = 24895;   // Replace extension ID with your extension ID
        $admin_support_email = 'support@cartbinder.com';
        
        $data['regerror_email'] = $this->language->get('regerror_email');
        $data['regerror_orderid'] = $this->language->get('regerror_orderid');
        $data['regerror_noreferer'] = $this->language->get('regerror_noreferer');
        $data['regerror_localhost'] = $this->language->get('regerror_localhost');
        $data['regerror_licensedupe'] = $this->language->get('regerror_licensedupe');
        $data['regerror_quote_msg'] = $this->language->get('regerror_quote_msg');
        $data['license_purchase_thanks'] = sprintf($this->language->get('license_purchase_thanks'), $admin_support_email);
        $data['license_registration'] = $this->language->get('license_registration');
        $data['license_opencart_email'] = $this->language->get('license_opencart_email');
        $data['license_opencart_orderid'] = $this->language->get('license_opencart_orderid');
        $data['check_email'] = $this->language->get('check_email');
        $data['check_orderid'] = $this->language->get('check_orderid');
        $data['server_error_curl'] = $this->language->get('server_error_curl');

        if(isset($this->request->get['emailmal'])){
          $data['emailmal'] = true;
        }

        if(isset($this->request->get['regerror'])){
            if($this->request->get['regerror']=='emailmal'){
              $this->error['warning'] = $this->language->get('regerror_email');
            }elseif($this->request->get['regerror']=='orderidmal'){
              $this->error['warning'] = $this->language->get('regerror_orderid');
            }elseif($this->request->get['regerror']=='noreferer'){
              $this->error['warning'] = $this->language->get('regerror_noreferer');
            }elseif($this->request->get['regerror']=='localhost'){
              $this->error['warning'] = $this->language->get('regerror_localhost');
            }elseif($this->request->get['regerror']=='licensedupe'){
              $this->error['warning'] = $this->language->get('regerror_licensedupe');
            }
        }

        $domainssl = explode("//", HTTPS_SERVER);
        $domainnonssl = explode("//", HTTP_SERVER);
        $domain = ($domainssl[1] != '' ? $domainssl[1] : $domainnonssl[1]);
        $data['domain'] = $domain;

        $data['licensed'] = @file_get_contents($data['oc_licensing_home'] . 'licensed.php?domain=' . $domain . '&extension=' . $data['extension_id']);

        if(!$data['licensed'] || $data['licensed'] == ''){
          if(extension_loaded('curl')) {
                $post_data = array('domain' => $domain, 'extension' => $data['extension_id']);
                $curl = curl_init();
                curl_setopt($curl, CURLOPT_HEADER, false);
                curl_setopt($curl, CURLINFO_HEADER_OUT, true);
                curl_setopt($curl, CURLOPT_USERAGENT,'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.17 (KHTML, like Gecko) Chrome/24.0.1312.52 Safari/537.17');
                $follow_allowed = ( ini_get('open_basedir') || ini_get('safe_mode')) ? false : true;
                if ($follow_allowed) {
                    curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1);
                }
                curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 9);
                curl_setopt($curl, CURLOPT_TIMEOUT, 60);
                curl_setopt($curl, CURLOPT_AUTOREFERER, true); 
                curl_setopt($curl, CURLOPT_VERBOSE, 1);
                curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
                curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
                curl_setopt($curl, CURLOPT_FORBID_REUSE, false);
                curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($curl, CURLOPT_URL, $data['oc_licensing_home'] . 'licensed.php');
                curl_setopt($curl, CURLOPT_POST, true);
                curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($post_data));
                $data['licensed'] = curl_exec($curl);
                curl_close($curl);
            }else{
                $data['licensed'] = 'curl';
            }
        }

        $data['licensed_md5'] = md5($data['licensed']);

		$data['salesagent_register'] = $this->config->get('salesagent_register');
		$data['salesagent_checkout'] = $this->config->get('salesagent_checkout');
		$data['salesagent_backend_checkout'] = $this->config->get('salesagent_backend_checkout');
		$data['salesagent_orderhistory'] = $this->config->get('salesagent_orderhistory');
		$data['salesagent_commissiontotal'] = $this->config->get('salesagent_commissiontotal');
		$data['salesagent_coupondiscount'] = $this->config->get('salesagent_coupondiscount');
		$data['salesagent_recurrsive'] = $this->config->get('salesagent_recurrsive');
		$data['salesagent_customershow'] = $this->config->get('salesagent_customershow');

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('tool/salesagent_list.tpl', $data));
	}

	protected function getForm() {
		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_form'] = !isset($this->request->get['salesagent_id']) ? $this->language->get('text_add') : $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_tip2'] = $this->language->get('text_tip2');
		$data['text_howitworks'] = $this->language->get('text_howitworks');
		$data['text_howitworks_content'] = $this->language->get('text_howitworks_content');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_clist'] = $this->language->get('text_clist');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');
		$data['text_select'] = $this->language->get('text_select');
		$data['text_none'] = $this->language->get('text_none');
		$data['text_loading'] = $this->language->get('text_loading');
		$data['text_pleaseselect'] = $this->language->get('text_pleaseselect');
		$data['text_add_ban_ip'] = $this->language->get('text_add_ban_ip');
		$data['text_remove_ban_ip'] = $this->language->get('text_remove_ban_ip');
		$data['text_salesagent_clist'] = $this->language->get('text_salesagent_clist');

		$data['entry_salesagent_group'] = $this->language->get('entry_salesagent_group');
		$data['entry_firstname'] = $this->language->get('entry_firstname');
		$data['entry_lastname'] = $this->language->get('entry_lastname');
		$data['entry_email'] = $this->language->get('entry_email');
		$data['entry_telephone'] = $this->language->get('entry_telephone');
		$data['entry_fax'] = $this->language->get('entry_fax');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_alertemail'] = $this->language->get('entry_alertemail');
		$data['entry_commission'] = $this->language->get('entry_commission');
		$data['entry_city'] = $this->language->get('entry_city');
		$data['entry_user'] = $this->language->get('entry_user');
		$data['entry_address'] = $this->language->get('entry_address');
		$data['entry_uniqueid'] = $this->language->get('entry_uniqueid');
		$data['entry_default'] = $this->language->get('entry_default');
		$data['entry_expiry_date'] = $this->language->get('entry_expiry_date');
		$data['entry_parent'] = $this->language->get('entry_parent');
		$data['entry_parent_commission'] = $this->language->get('entry_parent_commission');
		$data['text_second_parent'] = $this->language->get('text_second_parent');
		$data['entry_second_parent_commission'] = $this->language->get('entry_second_parent_commission');
		$data['entry_clist'] = $this->language->get('entry_clist');
		

		$data['uniqueid_help'] = $this->language->get('uniqueid_help');
		$data['uniqueid_exist'] = $this->language->get('uniqueid_exist');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_add'] = $this->language->get('button_add');
		$data['button_cancel'] = $this->language->get('button_cancel');

		$data['token'] = $this->session->data['token'];

		if (isset($this->request->get['salesagent_id'])) {
			$data['salesagent_id'] = $this->request->get['salesagent_id'];
		} else {
			$data['salesagent_id'] = 0;
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['firstname'])) {
			$data['error_firstname'] = $this->error['firstname'];
		} else {
			$data['error_firstname'] = '';
		}

		if (isset($this->error['lastname'])) {
			$data['error_lastname'] = $this->error['lastname'];
		} else {
			$data['error_lastname'] = '';
		}

		if (isset($this->error['email'])) {
			$data['error_email'] = $this->error['email'];
		} else {
			$data['error_email'] = '';
		}

		if (isset($this->error['telephone'])) {
			$data['error_telephone'] = $this->error['telephone'];
		} else {
			$data['error_telephone'] = '';
		}

		$url = '';

		if (isset($this->request->get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode($this->request->get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['filter_email'])) {
			$url .= '&filter_email=' . urlencode(html_entity_decode($this->request->get['filter_email'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['filter_status'])) {
			$url .= '&filter_status=' . $this->request->get['filter_status'];
		}

		if (isset($this->request->get['filter_date_added'])) {
			$url .= '&filter_date_added=' . $this->request->get['filter_date_added'];
		}

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('tool/salesagent', 'token=' . $this->session->data['token'] . $url, 'SSL')
		);

		if (!isset($this->request->get['salesagent_id'])) {
			$data['action'] = $this->url->link('tool/salesagent/add', 'token=' . $this->session->data['token'] . $url, 'SSL');
		} else {
			$data['action'] = $this->url->link('tool/salesagent/edit', 'token=' . $this->session->data['token'] . '&salesagent_id=' . $this->request->get['salesagent_id'] . $url, 'SSL');
		}

		$data['cancel'] = $this->url->link('tool/salesagent', 'token=' . $this->session->data['token'] . $url, 'SSL');
		$data['clist'] = $this->url->link('tool/salesagentclist', 'token=' . $this->session->data['token'] . $url, 'SSL');

		if (isset($this->request->get['salesagent_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$salesagent_info = $this->model_tool_salesagent->getsalesagent($this->request->get['salesagent_id']);
		}

		$data['users'] = $this->db->query("SELECT * FROM `" . DB_PREFIX . "user`")->rows;

		if (isset($this->request->post['user_id'])) {
			$data['user_id'] = $this->request->post['user_id'];
		} elseif (!empty($salesagent_info)) {
			$data['user_id'] = $salesagent_info['user_id'];
		} else {
			$data['user_id'] = '';
		}

		if (isset($this->request->post['firstname'])) {
			$data['firstname'] = $this->request->post['firstname'];
		} elseif (!empty($salesagent_info)) {
			$data['firstname'] = $salesagent_info['firstname'];
		} else {
			$data['firstname'] = '';
		}

		if (isset($this->request->post['lastname'])) {
			$data['lastname'] = $this->request->post['lastname'];
		} elseif (!empty($salesagent_info)) {
			$data['lastname'] = $salesagent_info['lastname'];
		} else {
			$data['lastname'] = '';
		}

		if (isset($this->request->post['uniqueid'])) {
			$data['uniqueid'] = $this->request->post['uniqueid'];
		} elseif (!empty($salesagent_info)) {
			$data['uniqueid'] = $salesagent_info['uniqueid'];
		} else {
			$data['uniqueid'] = '';
		}

		if (isset($this->request->post['email'])) {
			$data['email'] = $this->request->post['email'];
		} elseif (!empty($salesagent_info)) {
			$data['email'] = $salesagent_info['email'];
		} else {
			$data['email'] = '';
		}

		if (isset($this->request->post['telephone'])) {
			$data['telephone'] = $this->request->post['telephone'];
		} elseif (!empty($salesagent_info)) {
			$data['telephone'] = $salesagent_info['telephone'];
		} else {
			$data['telephone'] = '';
		}

		if (isset($this->request->post['fax'])) {
			$data['fax'] = $this->request->post['fax'];
		} elseif (!empty($salesagent_info)) {
			$data['fax'] = $salesagent_info['fax'];
		} else {
			$data['fax'] = '';
		}

		if (isset($this->request->post['alertemail'])) {
			$data['alertemail'] = $this->request->post['alertemail'];
		} elseif (!empty($salesagent_info)) {
			$data['alertemail'] = $salesagent_info['alertemail'];
		} else {
			$data['alertemail'] = '1';
		}

		if (isset($this->request->post['commission'])) {
			$data['commission'] = $this->request->post['commission'];
		} elseif (!empty($salesagent_info)) {
			$data['commission'] = $salesagent_info['commission'];
		} else {
			$data['commission'] = 80;
		}

		if (isset($this->request->post['status'])) {
			$data['status'] = $this->request->post['status'];
		} elseif (!empty($salesagent_info)) {
			$data['status'] = $salesagent_info['status'];
		} else {
			$data['status'] = true;
		}

		if (isset($this->request->post['parent_id'])) {
			$data['parent_id'] = $this->request->post['parent_id'];
		} elseif (!empty($salesagent_info)) {
			$data['parent_id'] = $salesagent_info['parent_id'];
		} else {
			$data['parent_id'] = 0;
		}

		if($data['parent_id']) {
			$data['parentname'] = $this->model_tool_salesagent->getsalesagentname($data['parent_id']);
		} else {
			$data['parentname'] = "";
		}

		if (isset($this->request->post['parent_commission'])) {
			$data['parent_commission'] = $this->request->post['parent_commission'];
		} elseif (!empty($salesagent_info)) {
			$data['parent_commission'] = $salesagent_info['parent_commission'];
		} else {
			$data['parent_commission'] = 0;
		}

		if($data['parent_id']) {
			$data['second_parentname'] = $this->model_tool_salesagent->getSecondParentName($data['parent_id']);
		} else {
			$data['second_parentname'] = "-";
		}

		if (isset($this->request->post['second_parent_commission'])) {
			$data['second_parent_commission'] = $this->request->post['second_parent_commission'];
		} elseif (!empty($salesagent_info)) {
			$data['second_parent_commission'] = $salesagent_info['second_parent_commission'];
		} else {
			$data['second_parent_commission'] = 0;
		}

		if (isset($this->request->post['city'])) {
			$data['city'] = $this->request->post['city'];
		} elseif (!empty($salesagent_info)) {
			$data['city'] = $salesagent_info['city'];
		} else {
			$data['city'] = "";
		}

		if (isset($this->request->post['address'])) {
			$data['address'] = $this->request->post['address'];
		} elseif (!empty($salesagent_info)) {
			$data['address'] = $salesagent_info['address'];
		} else {
			$data['address'] = "";
		}

		if (isset($this->request->post['clists'])) {
			$data['clists'] = $this->request->post['clists'];
		} elseif (!empty($salesagent_info)) {
			$data['clists'] = $this->model_tool_salesagent->getsalesagentclist($this->request->get['salesagent_id']);
		} else {
			$data['clists'] = array();
		}
		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('tool/salesagent_form.tpl', $data));
	}

	protected function validateForm() {
		if (!$this->user->hasPermission('modify', 'tool/salesagent')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if ((utf8_strlen($this->request->post['firstname']) < 1) || (utf8_strlen(trim($this->request->post['firstname'])) > 32)) {
			$this->error['firstname'] = $this->language->get('error_firstname');
		}

		if ((utf8_strlen($this->request->post['lastname']) < 1) || (utf8_strlen(trim($this->request->post['lastname'])) > 32)) {
			$this->error['lastname'] = $this->language->get('error_lastname');
		}

		if ((utf8_strlen($this->request->post['email']) > 96) || !preg_match('/^[^\@]+@.*.[a-z]{2,15}$/i', $this->request->post['email'])) {
			$this->error['email'] = $this->language->get('error_email');
		}

		$salesagent_info = $this->model_tool_salesagent->getsalesagentByEmail($this->request->post['email']);

		if (!isset($this->request->get['salesagent_id'])) {
			if ($salesagent_info) {
				$this->error['warning'] = $this->language->get('error_exists');
			}
		} else {
			if ($salesagent_info && ($this->request->get['salesagent_id'] != $salesagent_info['salesagent_id'])) {
				$this->error['warning'] = $this->language->get('error_exists');
			}
			
			if ($this->request->get['salesagent_id'] == $this->request->post['parent_id']) {
				$this->error['warning'] = $this->language->get('error_same_parent');
			}
		}

		$this->request->post['uniqueid'] = preg_replace('/\s+/', '', $this->request->post['uniqueid']);
		$this->request->post['uniqueid'] = str_replace('&', '', $this->request->post['uniqueid']);
		$this->request->post['uniqueid'] = str_replace('?', '', $this->request->post['uniqueid']);
		$this->request->post['uniqueid'] = str_replace('%', '', $this->request->post['uniqueid']);
		if($this->request->post['uniqueid']) {
			$salesagent_unqid = $this->model_tool_salesagent->getsalesagentByUniqueid($this->request->post['uniqueid']);
			if (!isset($this->request->get['salesagent_id'])) {
				if ($salesagent_unqid) {
					$this->error['warning'] = $this->language->get('error_uniqueid_exists');
				}
			} else {
				if ($salesagent_unqid && ($this->request->get['salesagent_id'] != $salesagent_unqid['salesagent_id'])) {
					$this->error['warning'] = $this->language->get('error_uniqueid_exists');
				}
			}
		}

		if ((utf8_strlen($this->request->post['telephone']) < 3) || (utf8_strlen($this->request->post['telephone']) > 32)) {
			$this->error['telephone'] = $this->language->get('error_telephone');
		}
		$tempclist = array();
		if(isset($this->request->post['clists'])) {
			foreach ($this->request->post['clists'] as $key => $value) {
				if(in_array($value['clist_id'], $tempclist)) {
					$this->error['warning'] = $this->language->get('error_clist');
				} else {
					$tempclist[] = $value['clist_id'];
				}
			}
		}
		if ($this->error && !isset($this->error['warning'])) {
			$this->error['warning'] = $this->language->get('error_warning');
		}

		return !$this->error;
	}

	protected function validateDelete() {
		if (!$this->user->hasPermission('modify', 'tool/salesagent')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}

	
	public function autocomplete() {
		$json = array();

		if (isset($this->request->get['filter_name']) || isset($this->request->get['filter_email'])) {
			if (isset($this->request->get['filter_name'])) {
				$filter_name = $this->request->get['filter_name'];
			} else {
				$filter_name = '';
			}

			if (isset($this->request->get['filter_email'])) {
				$filter_email = $this->request->get['filter_email'];
			} else {
				$filter_email = '';
			}

			$this->load->model('tool/salesagent');

			$filter_data = array(
				'filter_name'  => $filter_name,
				'filter_email' => $filter_email,
				'start'        => 0,
				'limit'        => 5
			);

			$results = $this->model_tool_salesagent->getsalesagents($filter_data);

			foreach ($results as $result) {
				$json[] = array(
					'salesagent_id'     => $result['salesagent_id'],
					'parentname'		=> $this->model_tool_salesagent->getSecondParentName($result['salesagent_id']),
					'firstname'         => $result['firstname'],
					'lastname'          => $result['lastname'],
					'name'              => $result['firstname']." ".$result['lastname'],
					'email'             => $result['email'],
					'telephone'         => $result['telephone'],
					'fax'               => $result['fax']
				);
			}
		}

		$sort_order = array();

		foreach ($json as $key => $value) {
			$sort_order[$key] = $value['firstname'];
		}

		array_multisort($sort_order, SORT_ASC, $json);

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}

	public function savesettings() {
		$this->load->model('setting/setting');
		$temp['salesagent_checkout'] =  $this->request->get['salesagent_checkout'];
		$temp['salesagent_installed'] =  1;
		$temp['salesagent_backend_checkout'] =  $this->request->get['salesagent_backend_checkout'];
		$temp['salesagent_register'] =  $this->request->get['salesagent_register'];
		$temp['salesagent_orderhistory'] =  $this->request->get['salesagent_orderhistory'];
		$temp['salesagent_commissiontotal'] =  $this->request->get['salesagent_commissiontotal'];
		$temp['salesagent_coupondiscount'] =  $this->request->get['salesagent_coupondiscount'];
		$temp['salesagent_recurrsive'] =  $this->request->get['salesagent_recurrsive'];
		$temp['salesagent_customershow'] =  $this->request->get['salesagent_customershow'];
		
		if (!$this->user->hasPermission('modify', 'tool/salesagent')) {
			$json['error'] =   "No Permission to change settings. Only main admin can change this.";
		} else {
			$this->model_setting_setting->editSetting('salesagent', $temp);
			$json['success'] = "Settings has been saved";
		}
		$this->response->setOutput(json_encode($json));
	} 
}
