<?php
class ModelCommonMainMenu extends Model {
	public function getMenus($parent_id = 0) {
		if ($this->user->isLogged() && $this->user->getDefaultGroupId()) {
			$sql = "SELECT m.menu_id AS menu_id, m.icon, m.link, m.position, m.addition, md.name, md.description FROM " . DB_PREFIX . "emenu m LEFT JOIN " . DB_PREFIX . "emenu_description md ON (m.menu_id = md.menu_id) WHERE m.parent_id = '" . (int)$parent_id . "' AND md.language_id = '" . (int)$this->config->get('config_language_id') . "' AND m.status = '1' ORDER BY m.sort_order, LCASE(md.name)";
		} else {
			$sql = "SELECT m.menu_id AS menu_id, m.icon, m.link, m.position, m.addition, md.name, md.description, m2ug.user_group_id FROM " . DB_PREFIX . "emenu m LEFT JOIN " . DB_PREFIX . "emenu_description md ON (m.menu_id = md.menu_id) LEFT JOIN " . DB_PREFIX . "emenu_to_user_group m2ug ON (m.menu_id = m2ug.menu_id) WHERE m.parent_id = '" . (int)$parent_id . "' AND md.language_id = '" . (int)$this->config->get('config_language_id') . "' AND m2ug.user_group_id = '" . (int)$this->user->getGroupId() . "' AND m.status = '1' ORDER BY m.sort_order, LCASE(md.name)";
		}

		$menu_data = array();

		$menu_query = $this->db->query($sql);

		foreach ($menu_query->rows as $menu) {
			// Level 2
			$level2_data = array();
			$level2 = $this->getMenus($menu['menu_id']);

			foreach ($level2 as $child2) {
				// Level 3
				$level3_data = array();
				$level3 = $this->getMenus($child2['menu_id']);

				foreach ($level3 as $child3) {
					// Level 4
					$level4_data = array();
					$level4 = $this->getMenus($child3['menu_id']);

					foreach ($level4 as $child4) {
						$level4_data[] = array(
							'menu_id' => $child4['menu_id'],
							'name'    => $child4['name'],
							'route'   => $child4['route'],
							'href'    => $child4['href'],
							'icon'    => $child4['icon']
						);
					}

					$level3_data[] = array(
						'menu_id' => $child3['menu_id'],
						'name'    => $child3['name'],
						'route'   => $child3['route'],
						'href'    => $child3['href'],
						'icon'    => $child3['icon'],
						'level4'  => $level4_data
					);
				}

				$level2_data[] = array(
					'menu_id' => $child2['menu_id'],
					'name'    => $child2['name'],
					'route'   => $child2['route'],
					'href'    => $child2['href'],
					'icon'    => $child2['icon'],
					'level3'  => $level3_data
				);
			}

			if ($menu['icon']) {
				$icon = ' '.$menu['icon'];
			} else {
				$icon = false;
			}

			$token = 'token=' . $this->session->data['token'];

			$menu_data[] = array(
				'menu_id'  => $menu['menu_id'],
				'position' => $menu['position'],
				'name'     => $menu['name'],
				'route'    => $menu['link'],
				'href'     => $this->url->link($menu['link'] . ($menu['addition'] ? '/' . $menu['addition'] : ''), $token, true),
				'icon'     => $icon,
				'addition' => $menu['addition'],
				'level2'   => $level2_data
			);
		}

		return $menu_data;
	}

	public function getMenuUserGroup($user_group_id) {
		$query = $this->db->query("SELECT DISTINCT m.menu_id, m2ug.user_group_id FROM " . DB_PREFIX . "emenu m LEFT JOIN " . DB_PREFIX . "emenu_to_user_group m2ug ON (m.menu_id = m2ug.menu_id) WHERE m.link = '0' AND m2ug.user_group_id = '" . (int)$user_group_id . "'");

		return $query->row;
	}
}