<?php
class ModelSettingMenu extends Model {
	public function addMenu($data) {
		$this->db->query("INSERT INTO " . DB_PREFIX . "emenu SET parent_id = '" . (int)$data['parent_id'] . "', link = '" . $this->db->escape($data['link']) . "', addition = '" . $this->db->escape($data['addition']) . "', icon = '" . $this->db->escape($data['icon']) . "', position = '" . $this->db->escape($data['position']) . "', sort_order = '" . (int)$data['sort_order'] . "', status = '" . (int)$data['status'] . "', date_modified = '" . $this->db->escape(date('Y-m-d H:i:s')) . "', date_added = '" . $this->db->escape(date('Y-m-d H:i:s')) . "'");

		$menu_id = $this->db->getLastId();

		foreach ($data['menu_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "emenu_description SET menu_id = '" . (int)$menu_id . "', language_id = '" . (int)$language_id . "', name = '" . $this->db->escape($value['name']) . "', description = '" . $this->db->escape($value['description']) . "'");
		}

		// MySQL Hierarchical Data Closure Table Pattern
		$level = 0;

		$query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "emenu_path` WHERE menu_id = '" . (int)$data['parent_id'] . "' ORDER BY `level` ASC");

		foreach ($query->rows as $result) {
			$this->db->query("INSERT INTO `" . DB_PREFIX . "emenu_path` SET `menu_id` = '" . (int)$menu_id . "', `path_id` = '" . (int)$result['path_id'] . "', `level` = '" . (int)$level . "'");

			$level++;
		}

		$this->db->query("INSERT INTO `" . DB_PREFIX . "emenu_path` SET `menu_id` = '" . (int)$menu_id . "', `path_id` = '" . (int)$menu_id . "', `level` = '" . (int)$level . "'");

		if (isset($data['menu_user_group'])) {
			foreach ($data['menu_user_group'] as $user_group_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "emenu_to_user_group SET menu_id = '" . (int)$menu_id . "', user_group_id = '" . (int)$user_group_id . "'");
			}
		}

		$this->cache->delete('emenu');
	}

	public function editMenu($menu_id, $data) {
		$this->db->query("UPDATE " . DB_PREFIX . "emenu SET parent_id = '" . (int)$data['parent_id'] . "', link = '" . $this->db->escape($data['link']) . "', addition = '" . $this->db->escape($data['addition']) . "', icon = '" . $this->db->escape($data['icon']) . "', position = '" . $this->db->escape($data['position']) . "', sort_order = '" . (int)$data['sort_order'] . "', status = '" . (int)$data['status'] . "', date_modified = '" . $this->db->escape(date('Y-m-d H:i:s')) . "' WHERE menu_id = '" . (int)$menu_id . "'");

		$this->db->query("DELETE FROM " . DB_PREFIX . "emenu_description WHERE menu_id = '" . (int)$menu_id . "'");

		foreach ($data['menu_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "emenu_description SET menu_id = '" . (int)$menu_id . "', language_id = '" . (int)$language_id . "', name = '" . $this->db->escape($value['name']) . "', description = '" . $this->db->escape($value['description']) . "'");
		}

		// MySQL Hierarchical Data Closure Table Pattern
		$query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "emenu_path` WHERE path_id = '" . (int)$menu_id . "' ORDER BY level ASC");

		if ($query->rows) {
			foreach ($query->rows as $menu_path) {
				// Delete the path below the current one
				$this->db->query("DELETE FROM `" . DB_PREFIX . "emenu_path` WHERE menu_id = '" . (int)$menu_path['menu_id'] . "' AND level < '" . (int)$menu_path['level'] . "'");

				$path = array();

				// Get the nodes new parents
				$query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "emenu_path` WHERE menu_id = '" . (int)$data['parent_id'] . "' ORDER BY level ASC");

				foreach ($query->rows as $result) {
					$path[] = $result['path_id'];
				}

				// Get whats left of the nodes current path
				$query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "emenu_path` WHERE menu_id = '" . (int)$menu_path['menu_id'] . "' ORDER BY level ASC");

				foreach ($query->rows as $result) {
					$path[] = $result['path_id'];
				}

				// Combine the paths with a new level
				$level = 0;

				foreach ($path as $path_id) {
					$this->db->query("REPLACE INTO `" . DB_PREFIX . "emenu_path` SET menu_id = '" . (int)$menu_path['menu_id'] . "', `path_id` = '" . (int)$path_id . "', level = '" . (int)$level . "'");

					$level++;
				}
			}
		} else {
			// Delete the path below the current one
			$this->db->query("DELETE FROM `" . DB_PREFIX . "emenu_path` WHERE menu_id = '" . (int)$menu_id . "'");

			// Fix for records with no paths
			$level = 0;

			$query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "emenu_path` WHERE menu_id = '" . (int)$data['parent_id'] . "' ORDER BY level ASC");

			foreach ($query->rows as $result) {
				$this->db->query("INSERT INTO `" . DB_PREFIX . "emenu_path` SET menu_id = '" . (int)$menu_id . "', `path_id` = '" . (int)$result['path_id'] . "', level = '" . (int)$level . "'");

				$level++;
			}

			$this->db->query("REPLACE INTO `" . DB_PREFIX . "emenu_path` SET menu_id = '" . (int)$menu_id . "', `path_id` = '" . (int)$menu_id . "', level = '" . (int)$level . "'");
		}

		$this->db->query("DELETE FROM " . DB_PREFIX . "emenu_to_user_group WHERE menu_id = '" . (int)$menu_id . "'");

		if (isset($data['menu_user_group'])) {
			foreach ($data['menu_user_group'] as $user_group_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "emenu_to_user_group SET menu_id = '" . (int)$menu_id . "', user_group_id = '" . (int)$user_group_id . "'");
			}
		}

		$this->cache->delete('emenu');
	}

	public function deleteMenu($menu_id) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "emenu_path WHERE menu_id = '" . (int)$menu_id . "'");

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "emenu_path WHERE path_id = '" . (int)$menu_id . "'");

		foreach ($query->rows as $result) {
			$this->deleteMenu($result['menu_id']);
		}

		$this->db->query("DELETE FROM " . DB_PREFIX . "emenu WHERE menu_id = '" . (int)$menu_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "emenu_description WHERE menu_id = '" . (int)$menu_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "emenu_to_user_group WHERE menu_id = '" . (int)$menu_id . "'");

		$this->cache->delete('emenu');
	}

	// Function to repair any erroneous categories that are not in the menu path table.
	public function repairMenus($parent_id = 0) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "emenu WHERE parent_id = '" . (int)$parent_id . "'");

		foreach ($query->rows as $menu) {
			// Delete the path below the current one
			$this->db->query("DELETE FROM `" . DB_PREFIX . "emenu_path` WHERE menu_id = '" . (int)$menu['menu_id'] . "'");

			// Fix for records with no paths
			$level = 0;

			$query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "emenu_path` WHERE menu_id = '" . (int)$parent_id . "' ORDER BY level ASC");

			foreach ($query->rows as $result) {
				$this->db->query("INSERT INTO `" . DB_PREFIX . "emenu_path` SET menu_id = '" . (int)$menu['menu_id'] . "', `path_id` = '" . (int)$result['path_id'] . "', level = '" . (int)$level . "'");

				$level++;
			}

			$this->db->query("REPLACE INTO `" . DB_PREFIX . "emenu_path` SET menu_id = '" . (int)$menu['menu_id'] . "', `path_id` = '" . (int)$menu['menu_id'] . "', level = '" . (int)$level . "'");

			$this->repairMenus($menu['menu_id']);
		}
	}

	public function copyMenu($menu_id) {
		$query = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "emenu m LEFT JOIN " . DB_PREFIX . "emenu_description md ON (m.menu_id = md.menu_id) WHERE m.menu_id = '" . (int)$menu_id . "' AND md.language_id = '" . (int)$this->config->get('config_language_id') . "'");

		if ($query->num_rows) {
			$data = array();

			$data = $query->row;

			$data['status'] = '0';

			$data = array_merge($data, array('menu_description' => $this->getMenuDescriptions($menu_id)));
			$data = array_merge($data, array('menu_user_group' => $this->getMenuUserGroups($menu_id)));

			$this->addMenu($data);
		}
	}

	public function getMenu($menu_id) {
		$query = $this->db->query("SELECT DISTINCT *, (SELECT GROUP_CONCAT(md1.name ORDER BY level SEPARATOR ' &gt; ') FROM " . DB_PREFIX . "emenu_path mp LEFT JOIN " . DB_PREFIX . "emenu_description md1 ON (mp.path_id = md1.menu_id AND mp.menu_id != mp.path_id) WHERE mp.menu_id = m.menu_id AND md1.language_id = '" . (int)$this->config->get('config_language_id') . "' GROUP BY mp.menu_id) AS path FROM " . DB_PREFIX . "emenu m LEFT JOIN " . DB_PREFIX . "emenu_description md2 ON (m.menu_id = md2.menu_id) WHERE m.menu_id = '" . (int)$menu_id . "' AND md2.language_id = '" . (int)$this->config->get('config_language_id') . "'");

		return $query->row;
	}

	public function getMenus($data = array()) {
		$sql = "SELECT mp.menu_id AS menu_id, GROUP_CONCAT(md1.name ORDER BY mp.level SEPARATOR ' &gt; ') AS name, m.parent_id, m.status, m.position, m.sort_order, (SELECT GROUP_CONCAT(md1.name ORDER BY level SEPARATOR ' &gt; ') FROM " . DB_PREFIX . "emenu_path mp LEFT JOIN " . DB_PREFIX . "emenu_description md1 ON (mp.path_id = md1.menu_id AND mp.menu_id != mp.path_id) WHERE mp.menu_id = m.menu_id AND md1.language_id = '" . (int)$this->config->get('config_language_id') . "' GROUP BY mp.menu_id) AS path FROM " . DB_PREFIX . "emenu_path mp LEFT JOIN " . DB_PREFIX . "emenu m ON (mp.menu_id = m.menu_id) LEFT JOIN " . DB_PREFIX . "emenu_description md1 ON (mp.path_id = md1.menu_id) LEFT JOIN " . DB_PREFIX . "emenu_description md2 ON (mp.menu_id = md2.menu_id) WHERE md1.language_id = '" . (int)$this->config->get('config_language_id') . "' AND md2.language_id = '" . (int)$this->config->get('config_language_id') . "'";

		if (!empty($data['filter_name'])) {
			$sql .= " AND md2.name LIKE '%" . $this->db->escape($data['filter_name']) . "%'";
		}

		$sql .= " GROUP BY mp.menu_id";

		$sort_data = array(
			'name',
			'path',
			'status'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}

	public function getMenuDescriptions($menu_id) {
		$menu_description_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "emenu_description WHERE menu_id = '" . (int)$menu_id . "'");

		foreach ($query->rows as $result) {
			$menu_description_data[$result['language_id']] = array(
				'name'        => $result['name'],
				'description' => $result['description']
			);
		}

		return $menu_description_data;
	}

	public function getMenuUserGroups($menu_id) {
		$menu_user_group_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "emenu_to_user_group WHERE menu_id = '" . (int)$menu_id . "'");

		foreach ($query->rows as $result) {
			$menu_user_group_data[] = $result['user_group_id'];
		}

		return $menu_user_group_data;
	}

	public function getTotalMenus() {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "emenu");

		return $query->row['total'];
	}

	// Ajax
	public function ajaxMenuStatus($menu_id, $status) {
		$this->db->query("UPDATE " . DB_PREFIX . "emenu SET status = '" . (int)$status . "' WHERE menu_id = '" . (int)$menu_id . "'");

		$this->cache->delete('emenu');
	}

	public function ajaxMenuOrder($menu_id, $sort_order) {
		$this->db->query("UPDATE " . DB_PREFIX . "emenu SET sort_order = '" . (int)$sort_order . "' WHERE menu_id = '" . (int)$menu_id . "'");

		$this->cache->delete('emenu');
	}

	public function getInstall() {
		/* Menu Data */
		$this->db->query(
		"CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "emenu` (
			`menu_id` int(11) NOT NULL AUTO_INCREMENT,
			`parent_id` int(11) NOT NULL DEFAULT '0',
			`link` varchar(255) DEFAULT NULL,
			`addition` varchar(255) DEFAULT NULL,
			`icon` varchar(255) DEFAULT NULL,
			`position` varchar(64) NOT NULL,
			`sort_order` int(3) NOT NULL DEFAULT '0',
			`status` tinyint(1) NOT NULL,
			`date_added` datetime NOT NULL,
			`date_modified` datetime NOT NULL,
			PRIMARY KEY (`menu_id`)
		) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;");

		/* Default Menu Data */
		$this->db->query(
		"INSERT INTO `" . DB_PREFIX . "emenu` (`menu_id`, `parent_id`, `link`, `addition`,  `icon`, `position`, `sort_order`, `status`, `date_added`, `date_modified`) VALUES
			(1, 31, 'setting/menu', '', '', 'left', 2, 1, '2013-10-20 15:40:33', '2013-10-20 15:40:33'),
			(2, 0, '0', '', 'fa-tags', 'left', 2, 1, '2013-10-20 15:41:10', '2015-03-12 12:21:56'),
			(3, 2, 'catalog/category', '', '', 'left', 1, 1, '2013-10-20 15:41:44', '2013-10-20 15:41:44'),
			(4, 2, 'catalog/product', '', '', 'left', 2, 1, '2013-10-20 15:42:12', '2013-10-20 15:42:22'),
			(5, 2, '0', '', '', 'left', 5, 1, '2013-10-20 15:43:16', '2013-10-20 15:43:26'),
			(6, 5, 'catalog/attribute', '', '', 'left', 1, 1, '2013-10-20 15:44:07', '2013-10-20 15:44:07'),
			(7, 5, 'catalog/attribute_group', '', '', 'left', 2, 1, '2013-10-20 15:44:41', '2013-10-20 15:44:41'),
			(8, 2, 'catalog/option', '', '', 'left', 6, 1, '2013-10-20 15:45:15', '2013-10-20 15:45:15'),
			(9, 2, 'catalog/manufacturer', '', '', 'left', 7, 1, '2013-10-20 15:46:12', '2013-10-20 15:46:12'),
			(10, 2, 'catalog/download', '', '', 'left', 8, 1, '2013-10-20 15:46:44', '2013-10-20 15:46:44'),
			(11, 2, 'catalog/review', '', '', 'left', 9, 1, '2013-10-20 15:47:24', '2013-10-20 15:47:24'),
			(12, 2, 'catalog/information', '', '', 'left', 10, 1, '2013-10-20 15:47:52', '2013-10-20 15:47:52'),
			(13, 0, '0', '', 'fa-puzzle-piece', 'left', 3, 1, '2013-10-20 15:48:22', '2015-03-12 12:22:16'),
			(14, 13, 'extension/installer', '', '', 'left', 3, 1, '2013-10-20 15:49:03', '2013-10-20 15:49:03'),
			(15, 13, 'extension/extension', '', '', 'left', 4, 1, '2013-10-20 15:49:29', '2013-10-20 15:49:29'),
			(16, 13, 'extension/modification', '', '', 'left', 5, 1, '2013-10-20 15:49:57', '2013-10-20 15:49:57'),
			(17, 13, 'extension/event', '', '', 'left', 6, 1, '2013-10-20 15:50:25', '2013-10-20 15:50:36'),
			(19, 0, '0', '', 'fa-shopping-cart', 'left', 3, 1, '2013-10-20 15:53:27', '2015-03-12 12:22:49'),
			(20, 19, 'sale/order', '', '', 'left', 1, 1, '2013-10-20 15:53:54', '2013-10-20 15:53:54'),
			(21, 19, 'sale/return', '', '', 'left', 2, 1, '2013-10-20 15:54:25', '2013-10-20 15:54:40'),
			(22, 19, '0', '', '', 'left', 3, 1, '2013-10-20 15:55:37', '2013-10-20 15:55:53'),
			(23, 22, 'customer/customer', '', '', 'left', 1, 1, '2013-10-20 15:56:19', '2013-10-20 15:56:19'),
			(24, 22, 'customer/customer_group', '', '', 'left', 2, 1, '2013-10-20 15:56:55', '2013-10-20 15:56:55'),
			(25, 81, 'marketing/affiliate', '', '', 'left', 2, 1, '2013-10-20 15:57:34', '2015-03-12 13:12:36'),
			(26, 58, 'report/sale_coupon', '', '', 'left', 5, 1, '2013-10-20 15:58:06', '2015-03-12 13:11:45'),
			(27, 19, '0', '', '', 'left', 6, 1, '2013-10-20 15:58:42', '2013-10-20 15:58:42'),
			(28, 27, 'sale/voucher', '', '', 'left', 1, 1, '2013-10-20 15:59:11', '2013-10-20 15:59:11'),
			(29, 27, 'sale/voucher_theme', '', '', 'left', 2, 1, '2013-10-20 15:59:49', '2013-10-20 15:59:49'),
			(30, 81, 'marketing/contact', '', '', 'left', 4, 1, '2013-10-20 16:00:36', '2015-03-12 13:13:15'),
			(31, 0, '0', '', 'fa-cog', 'left', 5, 1, '2013-10-20 16:01:08', '2015-03-12 12:23:26'),
			(32, 31, 'setting/store', '', '', 'left', 1, 1, '2013-10-20 16:01:49', '2013-10-20 16:01:49'),
			(33, 31, '0', '', '', 'left', 2, 1, '2013-10-20 16:02:50', '2013-10-20 16:02:50'),
			(34, 33, 'design/layout', '', '', 'left', 1, 1, '2013-10-20 16:03:17', '2013-10-20 16:03:17'),
			(35, 33, 'design/banner', '', '', 'left', 2, 1, '2013-10-20 16:03:41', '2013-10-20 16:03:41'),
			(36, 31, '0', '', '', 'left', 3, 1, '2013-10-20 16:04:05', '2013-10-20 16:04:05'),
			(37, 36, 'user/user', '', '', 'left', 1, 1, '2013-10-20 16:04:39', '2013-10-20 16:04:39'),
			(38, 36, 'user/user_permission', '', '', 'left', 2, 1, '2013-10-20 16:05:14', '2013-10-20 16:05:14'),
			(39, 31, '0', '', '', 'left', 4, 1, '2013-10-20 16:06:00', '2013-10-20 16:06:00'),
			(40, 39, 'localisation/language', '', '', 'left', 2, 1, '2013-10-20 16:06:31', '2013-10-20 16:06:31'),
			(41, 39, 'localisation/currency', '', '', 'left', 3, 1, '2013-10-20 16:07:17', '2013-10-20 16:07:17'),
			(42, 39, 'localisation/stock_status', '', '', 'left', 3, 1, '2013-10-20 16:08:04', '2013-10-20 16:08:04'),
			(43, 39, '0', '', '', 'left', 4, 1, '2013-10-20 16:09:14', '2013-10-20 16:09:14'),
			(44, 43, 'localisation/return_status', '', '', 'left', 1, 1, '2013-10-20 16:21:48', '2013-10-20 16:21:48'),
			(45, 43, 'localisation/return_action', '', '', 'left', 2, 1, '2013-10-20 16:23:32', '2013-10-20 16:23:32'),
			(46, 43, 'localisation/return_reason', '', '', 'left', 3, 1, '2013-10-20 16:24:01', '2013-10-20 16:24:20'),
			(47, 39, 'localisation/country', '', '', 'left', 5, 1, '2013-10-20 16:25:08', '2013-10-20 16:25:08'),
			(48, 39, 'localisation/zone', '', '', 'left', 6, 1, '2013-10-20 16:25:45', '2013-10-20 16:25:45'),
			(49, 39, 'localisation/geo_zone', '', '', 'left', 7, 1, '2013-10-20 16:26:05', '2013-10-20 16:26:05'),
			(50, 39, '0', '', '', 'left', 8, 1, '2013-10-20 16:29:42', '2013-10-20 16:29:42'),
			(51, 50, 'localisation/tax_class', '', '', 'left', 1, 1, '2013-10-20 16:30:26', '2013-10-20 16:30:26'),
			(52, 50, 'localisation/tax_rate', '', '', 'left', 2, 1, '2013-10-20 16:30:56', '2013-10-20 16:30:56'),
			(53, 39, 'localisation/length_class', '', '', 'left', 9, 1, '2013-10-20 16:31:33', '2013-10-20 16:31:33'),
			(54, 39, 'localisation/weight_class', '', '', 'left', 9, 1, '2013-10-20 16:32:06', '2013-10-20 16:32:06'),
			(55, 85, 'tool/error_log', '', '', 'left', 3, 1, '2013-10-20 16:33:30', '2015-03-12 13:22:36'),
			(56, 85, 'tool/backup', '', '', 'left', 2, 1, '2013-10-20 16:34:32', '2015-03-12 13:22:07'),
			(57, 0, '0', '', 'fa-bar-chart-o', 'left', 7, 1, '2013-10-20 16:34:57', '2015-03-12 12:24:00'),
			(58, 57, '0', '', '', 'left', 1, 1, '2013-10-20 16:35:44', '2013-10-20 16:35:44'),
			(59, 58, 'report/sale_order', '', '', 'left', 1, 1, '2013-10-20 16:36:43', '2013-10-20 16:36:43'),
			(60, 58, 'report/sale_tax', '', '', 'left', 2, 1, '2013-10-20 16:37:27', '2013-10-20 16:37:27'),
			(61, 58, 'report/sale_shipping', '', '', 'left', 3, 1, '2013-10-20 16:37:54', '2013-10-20 16:37:54'),
			(62, 58, 'report/sale_return', '', '', 'left', 4, 1, '2013-10-20 16:38:16', '2013-10-20 16:38:16'),
			(63, 81, 'marketing/coupon', '', '', 'left', 3, 1, '2013-10-20 16:38:54', '2015-03-12 13:10:03'),
			(64, 57, '0', '', '', 'left', 2, 1, '2013-10-20 16:47:24', '2013-10-20 16:47:24'),
			(65, 64, 'report/product_viewed', '', '', 'left', 1, 1, '2013-10-20 16:48:00', '2013-10-20 16:48:00'),
			(66, 64, 'report/product_purchased', '', '', 'left', 2, 1, '2013-10-20 16:48:43', '2013-10-20 16:48:43'),
			(67, 57, '0', '', '', 'left', 3, 1, '2013-10-20 16:49:08', '2013-10-20 16:49:08'),
			(68, 67, 'report/customer_online', '', '', 'left', 1, 1, '2013-10-20 16:49:37', '2013-10-20 16:50:25'),
			(69, 67, 'report/customer_order', '', '', 'left', 2, 1, '2013-10-20 16:50:55', '2013-10-20 16:50:55'),
			(70, 67, 'report/customer_reward', '', '', 'left', 3, 1, '2013-10-20 16:51:31', '2013-10-20 16:51:31'),
			(71, 67, 'report/customer_credit', '', '', 'left', 4, 1, '2013-10-20 16:51:57', '2013-10-20 16:51:57'),
			(72, 57, '0', '', '', 'left', 4, 1, '2013-10-20 16:52:24', '2015-03-12 13:35:41'),
			(73, 72, 'report/affiliate', '', '', 'left', 2, 1, '2013-10-20 16:52:52', '2015-03-12 13:37:00'),
			(74, 0, 'setting/menu', '', '', 'right', 1, 1, '2013-10-20 16:53:21', '2013-10-20 16:53:21'),
			(75, 39, 'localisation/order_status', '', '', 'left', 4, 1, '2014-02-01 16:52:49', '2014-02-01 16:52:49'),
			(76, 2, 'catalog/recurring', '', '', 'left', 3, 1, '2015-03-12 12:41:33', '2015-03-12 12:42:45'),
			(77, 2, 'catalog/filter', '', '', 'left', 4, 1, '2015-03-12 12:48:07', '2015-03-12 12:48:24'),
			(80, 19, 'sale/recurring', '', '', 'left', 2, 1, '2015-03-12 13:04:14', '2015-03-12 13:04:34'),
			(81, 0, '0', '', 'fa-share-alt', 'left', 4, 1, '2015-03-12 13:08:27', '2015-03-12 13:09:08'),
			(82, 81, 'marketing/marketing', '', '', 'left', 1, 1, '2015-03-12 13:14:42', '2015-03-12 13:15:01'),
			(83, 19, '0', '', '', 'left', 6, 1, '2015-03-12 13:16:23', '2015-03-12 13:16:51'),
			(84, 83, 'extension/payment/pp_express', 'search', '', 'left', 1, 1, '2015-03-12 13:17:18', '2015-03-12 13:17:55'),
			(85, 0, '0', '', 'fa-wrench', 'left', 6, 1, '2015-03-12 13:20:42', '2015-03-12 13:21:13'),
			(86, 85, 'tool/upload', '', '', 'left', 1, 1, '2015-03-12 13:22:53', '2015-03-12 13:23:18'),
			(87, 39, 'localisation/location', '', '', 'left', 1, 1, '2015-03-12 13:24:41', '2015-03-12 13:25:00'),
			(88, 36, 'user/api', '', '', 'left', 3, 1, '2015-03-12 13:26:39', '2015-03-12 13:27:01'),
			(89, 22, 'customer/custom_field', '', '', 'left', 3, 1, '2015-03-12 13:28:01', '2015-03-12 13:28:29'),
			(91, 67, 'report/customer_activity', '', '', 'left', 2, 1, '2015-03-12 13:34:52', '2015-03-12 13:35:11'),
			(92, 72, 'report/marketing', '', '', 'left', 1, 1, '2015-03-12 13:36:04', '2015-03-12 13:38:34'),
			(93, 72, 'report/affiliate_activity', '', '', 'left', 3, 1, '2015-03-12 13:36:16', '2015-03-12 13:38:19');");

		/* Menu Description Data */
		$this->db->query(
		"CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "emenu_description` (
			`menu_id` int(11) NOT NULL,
			`language_id` int(11) NOT NULL,
			`name` varchar(255) NOT NULL,
			`description` text NOT NULL,
			PRIMARY KEY (`menu_id`,`language_id`),
			KEY `name` (`name`)
		) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;");

		// Default Language
		$languages = array();

		$query_lang = $this->db->query("SELECT * FROM `" . DB_PREFIX . "language`");

		foreach ($query_lang->rows as $result) {
			$languages[$result['code']] = $result;
		}

		$default_language = $this->config->get('config_language_id', $languages[$this->config->get('config_admin_language')]['language_id']);

		/* Default Menu Description Data */
		$this->db->query(
		"INSERT INTO `" . DB_PREFIX . "emenu_description` (`menu_id`, `language_id`, `name`, `description`) VALUES
			(1, ".$default_language.", 'Menus', ''),
			(2, ".$default_language.", 'Catalog', ''),
			(3, ".$default_language.", 'Categories', ''),
			(4, ".$default_language.", 'Products', ''),
			(5, ".$default_language.", 'Attributes', ''),
			(6, ".$default_language.", 'Attributes', ''),
			(7, ".$default_language.", 'Attribute Groups', ''),
			(8, ".$default_language.", 'Options', ''),
			(9, ".$default_language.", 'Manufacturers', ''),
			(10, ".$default_language.", 'Downloads', ''),
			(11, ".$default_language.", 'Reviews', ''),
			(12, ".$default_language.", 'Information', ''),
			(13, ".$default_language.", 'Extensions', ''),
			(14, ".$default_language.", 'Extension Installer', ''),
			(15, ".$default_language.", 'Extensions', ''),
			(16, ".$default_language.", 'Modifications', ''),
			(17, ".$default_language.", 'Events', ''),
			(19, ".$default_language.", 'Sales', ''),
			(20, ".$default_language.", 'Orders', ''),
			(21, ".$default_language.", 'Returns', ''),
			(22, ".$default_language.", 'Customers', ''),
			(23, ".$default_language.", 'Customers', ''),
			(24, ".$default_language.", 'Customer Groups', ''),
			(25, ".$default_language.", 'Affiliates', ''),
			(26, ".$default_language.", 'Coupons', ''),
			(27, ".$default_language.", 'Gift Vouchers', ''),
			(28, ".$default_language.", 'Gift Vouchers', ''),
			(29, ".$default_language.", 'Voucher Themes', ''),
			(30, ".$default_language.", 'Bulk Mail', ''),
			(31, ".$default_language.", 'System', ''),
			(32, ".$default_language.", 'Stores', ''),
			(33, ".$default_language.", 'Design', ''),
			(34, ".$default_language.", 'Layouts', ''),
			(35, ".$default_language.", 'Banners', ''),
			(36, ".$default_language.", 'Users', ''),
			(37, ".$default_language.", 'Users', ''),
			(38, ".$default_language.", 'User Groups', ''),
			(39, ".$default_language.", 'Localisation', ''),
			(40, ".$default_language.", 'Languages', ''),
			(41, ".$default_language.", 'Currencies', ''),
			(42, ".$default_language.", 'Stock Statuses', ''),
			(43, ".$default_language.", 'Returns', ''),
			(44, ".$default_language.", 'Return Statuses', ''),
			(45, ".$default_language.", 'Return Actions', ''),
			(46, ".$default_language.", 'Return Reasons', ''),
			(47, ".$default_language.", 'Countries', ''),
			(48, ".$default_language.", 'Zones', ''),
			(49, ".$default_language.", 'Geo Zones', ''),
			(50, ".$default_language.", 'Taxes', ''),
			(51, ".$default_language.", 'Tax Classes', ''),
			(52, ".$default_language.", 'Tax Rates', ''),
			(53, ".$default_language.", 'Length Classes', ''),
			(54, ".$default_language.", 'Weight Classes', ''),
			(55, ".$default_language.", 'Error Logs', ''),
			(56, ".$default_language.", 'Backup / Restore', ''),
			(57, ".$default_language.", 'Reports', ''),
			(58, ".$default_language.", 'Sales', ''),
			(59, ".$default_language.", 'Orders', ''),
			(60, ".$default_language.", 'Tax', ''),
			(61, ".$default_language.", 'Shipping', ''),
			(62, ".$default_language.", 'Returns', ''),
			(63, ".$default_language.", 'Coupons', ''),
			(64, ".$default_language.", 'Products', ''),
			(65, ".$default_language.", 'Viewed', ''),
			(66, ".$default_language.", 'Purchased', ''),
			(67, ".$default_language.", 'Customers', ''),
			(68, ".$default_language.", 'Customers Online', ''),
			(69, ".$default_language.", 'Orders', ''),
			(70, ".$default_language.", 'Reward Points', ''),
			(71, ".$default_language.", 'Credit', ''),
			(72, ".$default_language.", 'Marketing', ''),
			(73, ".$default_language.", 'Affiliates', ''),
			(74, ".$default_language.", 'Menus', ''),
			(75, ".$default_language.", 'Order Statuses', ''),
			(76, ".$default_language.", 'Recurring Profiles', ''),
			(77, ".$default_language.", 'Filters', ''),
			(80, ".$default_language.", 'Recurring Orders', ''),
			(81, ".$default_language.", 'Marketing', ''),
			(82, ".$default_language.", 'Marketing', ''),
			(83, ".$default_language.", 'PayPal', ''),
			(84, ".$default_language.", 'Search', ''),
			(85, ".$default_language.", 'Tools', ''),
			(86, ".$default_language.", 'Uploads', ''),
			(87, ".$default_language.", 'Store Locations', ''),
			(88, ".$default_language.", 'API', ''),
			(89, ".$default_language.", 'Custom Fields', ''),
			(91, ".$default_language.", 'Customer Activity', ''),
			(92, ".$default_language.", 'Marketing', ''),
			(93, ".$default_language.", 'Affiliate Activity', '');");

		/* Menu Path Data */
		$this->db->query(
		"CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "emenu_path` (
			`menu_id` int(11) NOT NULL,
			`path_id` int(11) NOT NULL,
			`level` int(11) NOT NULL,
			PRIMARY KEY (`menu_id`,`path_id`)
		) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;");

		/* Default Menu Path Data */
		$this->db->query(
		"INSERT INTO `" . DB_PREFIX . "emenu_path` (`menu_id`, `path_id`, `level`) VALUES
			(1, 31, 0),
			(1, 1, 1),
			(2, 2, 0),
			(3, 2, 0),
			(3, 3, 1),
			(4, 4, 1),
			(4, 2, 0),
			(5, 2, 0),
			(5, 5, 1),
			(6, 2, 0),
			(6, 5, 1),
			(6, 6, 2),
			(7, 2, 0),
			(7, 5, 1),
			(7, 7, 2),
			(8, 2, 0),
			(8, 8, 1),
			(9, 2, 0),
			(9, 9, 1),
			(10, 2, 0),
			(10, 10, 1),
			(11, 2, 0),
			(11, 11, 1),
			(12, 2, 0),
			(12, 12, 1),
			(13, 13, 0),
			(14, 13, 0),
			(14, 14, 1),
			(15, 13, 0),
			(15, 15, 1),
			(16, 13, 0),
			(16, 16, 1),
			(17, 17, 1),
			(17, 13, 0),
			(19, 19, 0),
			(20, 19, 0),
			(20, 20, 1),
			(21, 21, 1),
			(21, 19, 0),
			(22, 22, 1),
			(22, 19, 0),
			(23, 19, 0),
			(23, 22, 1),
			(23, 23, 2),
			(24, 19, 0),
			(24, 22, 1),
			(24, 24, 2),
			(25, 81, 0),
			(25, 25, 1),
			(26, 57, 0),
			(26, 26, 2),
			(27, 19, 0),
			(27, 27, 1),
			(28, 19, 0),
			(28, 27, 1),
			(28, 28, 2),
			(29, 19, 0),
			(29, 27, 1),
			(29, 29, 2),
			(30, 81, 0),
			(30, 30, 1),
			(31, 31, 0),
			(32, 31, 0),
			(32, 32, 1),
			(33, 31, 0),
			(33, 33, 1),
			(34, 31, 0),
			(34, 33, 1),
			(34, 34, 2),
			(35, 31, 0),
			(35, 33, 1),
			(35, 35, 2),
			(36, 31, 0),
			(36, 36, 1),
			(37, 31, 0),
			(37, 36, 1),
			(37, 37, 2),
			(38, 31, 0),
			(38, 36, 1),
			(38, 38, 2),
			(39, 31, 0),
			(39, 39, 1),
			(40, 31, 0),
			(40, 39, 1),
			(40, 40, 2),
			(41, 31, 0),
			(41, 39, 1),
			(41, 41, 2),
			(42, 31, 0),
			(42, 39, 1),
			(42, 42, 2),
			(43, 31, 0),
			(43, 39, 1),
			(43, 43, 2),
			(44, 31, 0),
			(44, 39, 1),
			(44, 43, 2),
			(44, 44, 3),
			(45, 31, 0),
			(45, 39, 1),
			(45, 43, 2),
			(45, 45, 3),
			(46, 46, 3),
			(46, 31, 0),
			(46, 39, 1),
			(46, 43, 2),
			(47, 31, 0),
			(47, 39, 1),
			(47, 47, 2),
			(48, 31, 0),
			(48, 39, 1),
			(48, 48, 2),
			(49, 31, 0),
			(49, 39, 1),
			(49, 49, 2),
			(50, 31, 0),
			(50, 39, 1),
			(50, 50, 2),
			(51, 31, 0),
			(51, 39, 1),
			(51, 50, 2),
			(51, 51, 3),
			(52, 31, 0),
			(52, 39, 1),
			(52, 50, 2),
			(52, 52, 3),
			(53, 31, 0),
			(53, 39, 1),
			(53, 53, 2),
			(54, 31, 0),
			(54, 39, 1),
			(54, 54, 2),
			(55, 85, 0),
			(55, 55, 1),
			(56, 85, 0),
			(56, 56, 1),
			(57, 57, 0),
			(58, 57, 0),
			(58, 58, 1),
			(59, 57, 0),
			(59, 58, 1),
			(59, 59, 2),
			(60, 57, 0),
			(60, 58, 1),
			(60, 60, 2),
			(61, 57, 0),
			(61, 58, 1),
			(61, 61, 2),
			(62, 57, 0),
			(62, 58, 1),
			(62, 62, 2),
			(26, 58, 1),
			(63, 81, 0),
			(63, 63, 1),
			(64, 57, 0),
			(64, 64, 1),
			(65, 57, 0),
			(65, 64, 1),
			(65, 65, 2),
			(66, 57, 0),
			(66, 64, 1),
			(66, 66, 2),
			(67, 57, 0),
			(67, 67, 1),
			(68, 67, 1),
			(68, 57, 0),
			(68, 68, 2),
			(69, 57, 0),
			(69, 67, 1),
			(69, 69, 2),
			(70, 57, 0),
			(70, 67, 1),
			(70, 70, 2),
			(71, 57, 0),
			(71, 67, 1),
			(71, 71, 2),
			(72, 57, 0),
			(72, 72, 1),
			(73, 72, 1),
			(73, 57, 0),
			(73, 73, 2),
			(74, 74, 0),
			(75, 31, 0),
			(75, 39, 1),
			(75, 75, 2),
			(76, 2, 0),
			(76, 76, 1),
			(77, 2, 0),
			(77, 77, 1),
			(80, 19, 0),
			(80, 80, 1),
			(81, 81, 0),
			(82, 81, 0),
			(82, 82, 1),
			(83, 19, 0),
			(83, 83, 1),
			(84, 83, 1),
			(84, 19, 0),
			(84, 84, 2),
			(85, 85, 0),
			(86, 85, 0),
			(86, 86, 1),
			(87, 39, 1),
			(87, 31, 0),
			(87, 87, 2),
			(88, 36, 1),
			(88, 31, 0),
			(88, 88, 2),
			(89, 22, 1),
			(89, 19, 0),
			(89, 89, 2),
			(91, 67, 1),
			(91, 57, 0),
			(91, 91, 2),
			(92, 57, 0),
			(92, 72, 1),
			(92, 92, 2),
			(93, 72, 1),
			(93, 57, 0),
			(93, 93, 2);");

		/* Menu to User Group Data */
		$this->db->query(
		"CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "emenu_to_user_group` (
			`menu_id` int(11) NOT NULL,
			`user_group_id` int(11) NOT NULL,
			PRIMARY KEY (`menu_id`,`user_group_id`)
		) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;");

		/* Default Menu to User Group Data */
		if ($this->config->get('config_user_group_id')) {
			$default_user_group = $this->config->get('config_user_group_id');
		} else {
			$default_user_group = 1;
		}

		$this->db->query(
		"INSERT INTO `" . DB_PREFIX . "emenu_to_user_group` (`menu_id`, `user_group_id`) VALUES
			(1, ".$default_user_group."),
			(2, ".$default_user_group."),
			(3, ".$default_user_group."),
			(4, ".$default_user_group."),
			(5, ".$default_user_group."),
			(6, ".$default_user_group."),
			(7, ".$default_user_group."),
			(8, ".$default_user_group."),
			(9, ".$default_user_group."),
			(10, ".$default_user_group."),
			(11, ".$default_user_group."),
			(12, ".$default_user_group."),
			(13, ".$default_user_group."),
			(14, ".$default_user_group."),
			(15, ".$default_user_group."),
			(16, ".$default_user_group."),
			(17, ".$default_user_group."),
			(19, ".$default_user_group."),
			(20, ".$default_user_group."),
			(21, ".$default_user_group."),
			(22, ".$default_user_group."),
			(23, ".$default_user_group."),
			(24, ".$default_user_group."),
			(25, ".$default_user_group."),
			(26, ".$default_user_group."),
			(27, ".$default_user_group."),
			(28, ".$default_user_group."),
			(29, ".$default_user_group."),
			(30, ".$default_user_group."),
			(31, ".$default_user_group."),
			(32, ".$default_user_group."),
			(33, ".$default_user_group."),
			(34, ".$default_user_group."),
			(35, ".$default_user_group."),
			(36, ".$default_user_group."),
			(37, ".$default_user_group."),
			(38, ".$default_user_group."),
			(39, ".$default_user_group."),
			(40, ".$default_user_group."),
			(41, ".$default_user_group."),
			(42, ".$default_user_group."),
			(43, ".$default_user_group."),
			(44, ".$default_user_group."),
			(45, ".$default_user_group."),
			(46, ".$default_user_group."),
			(47, ".$default_user_group."),
			(48, ".$default_user_group."),
			(49, ".$default_user_group."),
			(50, ".$default_user_group."),
			(51, ".$default_user_group."),
			(52, ".$default_user_group."),
			(53, ".$default_user_group."),
			(54, ".$default_user_group."),
			(55, ".$default_user_group."),
			(56, ".$default_user_group."),
			(57, ".$default_user_group."),
			(58, ".$default_user_group."),
			(59, ".$default_user_group."),
			(60, ".$default_user_group."),
			(61, ".$default_user_group."),
			(62, ".$default_user_group."),
			(63, ".$default_user_group."),
			(64, ".$default_user_group."),
			(65, ".$default_user_group."),
			(66, ".$default_user_group."),
			(67, ".$default_user_group."),
			(68, ".$default_user_group."),
			(69, ".$default_user_group."),
			(70, ".$default_user_group."),
			(71, ".$default_user_group."),
			(72, ".$default_user_group."),
			(73, ".$default_user_group."),
			(74, ".$default_user_group."),
			(75, ".$default_user_group."),
			(76, ".$default_user_group."),
			(77, ".$default_user_group."),
			(80, ".$default_user_group."),
			(81, ".$default_user_group."),
			(82, ".$default_user_group."),
			(83, ".$default_user_group."),
			(84, ".$default_user_group."),
			(85, ".$default_user_group."),
			(86, ".$default_user_group."),
			(87, ".$default_user_group."),
			(88, ".$default_user_group."),
			(89, ".$default_user_group."),
			(90, ".$default_user_group."),
			(91, ".$default_user_group."),
			(92, ".$default_user_group."),
			(93, ".$default_user_group.");");

		/* Default Setting */
		$this->db->query(
		"INSERT INTO `" . DB_PREFIX . "setting` (`setting_id`, `store_id`, `code`, `key`, `value`, `serialized`) VALUES
			('', '0', 'epiksel_menus', 'menu_control_version', '".EPMOD25_VERSION."', '0');");
	}

	public function getUpdate() {
		/* Version number update */
		if ($this->config->get('menu_control_version')) {
			$this->db->query("UPDATE `" . DB_PREFIX . "setting` SET `value` = '".EPMOD25_VERSION."' WHERE `key` = 'menu_control_version'");
		} else {
			$this->db->query(
		"INSERT INTO `" . DB_PREFIX . "setting` (`setting_id`, `store_id`, `code`, `key`, `value`, `serialized`) VALUES
			('', '0', 'epiksel_menus', 'menu_control_version', '".EPMOD25_VERSION."', '0');");
		}

		$menu_version_check = $this->config->get('menu_control_version');

		/* v1.1.0 Update */
		$db_check = $this->db->query("SHOW TABLES LIKE '" . DB_PREFIX . "emenu_to_user_group'");

		if ($menu_version_check < '1.1.0' && !$db_check->num_rows) {
			$this->db->query(
				"CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "emenu_to_user_group` (
				`menu_id` int(11) NOT NULL,
				`user_group_id` int(11) NOT NULL,
				PRIMARY KEY (`menu_id`,`user_group_id`)
			) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;");
		}

		/* v1.2.0 Update */
		$db_check = $this->db->query("SHOW TABLES LIKE '" . DB_PREFIX . "emenu_to_store'");

		if ($menu_version_check < '1.2.0' && $db_check->num_rows) {
			$this->db->query("DROP TABLE `" . DB_PREFIX . "emenu_to_store`;");
		}

		/* v2.0.0 Update */
		$column_exists = $this->db->query("SHOW COLUMNS FROM " . DB_PREFIX . "emenu LIKE 'icon'");

		if ($menu_version_check < '2.0.0' && !$column_exists->num_rows) {
			$this->db->query("ALTER TABLE ALTER TABLE `" . DB_PREFIX . "emenu` DROP `image`;");
			$this->db->query("ALTER TABLE `" . DB_PREFIX . "emenu` ADD `icon` varchar(255) DEFAULT NULL AFTER `addition`;");
		}
	}

	public function getUninstall() {
		$this->db->query("DROP TABLE `" . DB_PREFIX . "emenu`, `" . DB_PREFIX . "emenu_description`, `" . DB_PREFIX . "emenu_path`, `" . DB_PREFIX . "emenu_to_user_group`;");

		$this->load->model('setting/setting');
		$this->model_setting_setting->deleteSetting('epiksel_menus');
	}
}