<?php
class ControllerInformationConfirmation extends Controller {
	private $error = array();

	public function index() {
	
		$this->load->language('information/confirmation');

		$this->document->setTitle($this->language->get('heading_title'));

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$mail = new Mail();
			$mail->protocol = $this->config->get('config_mail_protocol');
			$mail->parameter = $this->config->get('config_mail_parameter');
			$mail->smtp_hostname = $this->config->get('config_mail_smtp_hostname');
			$mail->smtp_username = $this->config->get('config_mail_smtp_username');
			$mail->smtp_password = html_entity_decode($this->config->get('config_mail_smtp_password'), ENT_QUOTES, 'UTF-8');
			$mail->smtp_port = $this->config->get('config_mail_smtp_port');
			$mail->smtp_timeout = $this->config->get('config_mail_smtp_timeout');

			$mail->setTo($this->config->get('config_email'));
			$mail->setFrom($this->request->post['email']);
			$mail->setSender($this->request->post['atas_nama']);
                       
        	$email_body = $this->language->get('entry_orderid') . " :" . $this->request->post['orderid'] . "\n\r";
            $email_body .= $this->language->get('entry_email') . " :" . $this->request->post['email'] . "\n\r";
            $email_body .= $this->language->get('entry_rekening_asal') . " :" . $this->request->post['rekening_asal'] . "\n\r";
            $email_body .= $this->language->get('entry_atas_nama') . " :" . $this->request->post['atas_nama'] . "\n\r";
            $email_body .= $this->language->get('entry_rekening_tujuan') . " :" . $this->request->post['rekening_tujuan'] . "\n\r";
            $email_body .= $this->language->get('entry_jumlah_transfer') . " :" . $this->request->post['jumlah_transfer'] . "\n\r";
			
            $mail->setSubject(sprintf($this->language->get('email_subject'), $this->request->post['atas_nama']));
            $mail->setText(strip_tags(html_entity_decode($email_body, ENT_QUOTES, 'UTF-8')))  	;
	
            $mail->send();

			$this->response->redirect($this->url->link('information/confirmation/success'));
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('information/confirmation')
		);

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_location'] = $this->language->get('text_location');
		$data['text_store'] = $this->language->get('text_store');
		$data['text_confirmation'] = $this->language->get('text_confirmation');
		$data['text_address'] = $this->language->get('text_address');
		$data['text_telephone'] = $this->language->get('text_telephone');
		$data['text_fax'] = $this->language->get('text_fax');
		$data['text_open'] = $this->language->get('text_open');
		$data['text_comment'] = $this->language->get('text_comment');
//edit di sini
		$data['entry_orderid'] = $this->language->get('entry_orderid');
		$data['entry_email'] = $this->language->get('entry_email');
        $data['entry_rekening_asal'] = $this->language->get('entry_rekening_asal');
        $data['entry_atas_nama'] = $this->language->get('entry_atas_nama');
        $data['entry_rekening_tujuan'] = $this->language->get('entry_rekening_tujuan');
        $data['entry_jumlah_transfer'] = $this->language->get('entry_jumlah_transfer');
        $data['text_datapemesan']     = $this->language->get('text_datapemesan');
        $data['text_datakami']     = $this->language->get('text_datakami');
        $data['text_pilih']     = $this->language->get('text_pilih');
      
	

		$data['button_map'] = $this->language->get('button_map');
//edit di sini
		if (isset($this->error['orderid'])) {
			$data['error_orderid'] = $this->error['orderid'];
		} else {
			$data['error_orderid'] = '';
		}

		if (isset($this->error['email'])) {
			$data['error_email'] = $this->error['email'];
		} else {
			$data['error_email'] = '';
		}
        
        if (isset($this->error['rekening_asal'])) {
			$data['error_rekening_asal'] = $this->error['rekening_asal'];
		} else {
			$data['error_rekening_asal'] = '';
		}
        
        if (isset($this->error['atas_nama'])) {
			$data['error_atas_nama'] = $this->error['atas_nama'];
		} else {
			$data['error_atas_nama'] = '';
		}
        
        if (isset($this->error['rekening_tujuan'])) {
			$data['error_rekening_tujuan'] = $this->error['rekening_tujuan'];
		} else {
			$data['error_rekening_tujuan'] = '';
		}
        
         if (isset($this->error['jumlah_transfer'])) {
			$data['error_jumlah_transfer'] = $this->error['jumlah_transfer'];
		} else {
			$data['error_jumlah_transfer'] = '';
		}
        
         if (isset($this->error['bank'])) {
			$data['error_bank'] = $this->error['bank'];
		} else {
			$data['error_bank'] = '';
		}
         
		

		$data['button_kirim'] = $this->language->get('button_kirim');

		$data['action'] = $this->url->link('information/confirmation', '', true);

		$this->load->model('tool/image');

		if ($this->config->get('config_image')) {
			$data['image'] = $this->model_tool_image->resize($this->config->get('config_image'), $this->config->get($this->config->get('config_theme') . '_image_location_width'), $this->config->get($this->config->get('config_theme') . '_image_location_height'));
		} else {
			$data['image'] = false;
		}

		$data['store'] = $this->config->get('config_name');
		$data['address'] = nl2br($this->config->get('config_address'));
		$data['geocode'] = $this->config->get('config_geocode');
		$data['geocode_hl'] = $this->config->get('config_language');
		$data['telephone'] = $this->config->get('config_telephone');
		$data['fax'] = $this->config->get('config_fax');
		$data['open'] = nl2br($this->config->get('config_open'));
		$data['comment'] = $this->config->get('config_comment');

//array bank
        
        $data['banks']   = array(
				$this->language->get('bri'),
				$this->language->get('mandiri'),
				$this->language->get('bca'),
                $this->language->get('bni'),
			);

		$data['locations'] = array();

		$this->load->model('localisation/location');

		foreach((array)$this->config->get('config_location') as $location_id) {
			$location_info = $this->model_localisation_location->getLocation($location_id);

			if ($location_info) {
				if ($location_info['image']) {
					$image = $this->model_tool_image->resize($location_info['image'], $this->config->get($this->config->get('config_theme') . '_image_location_width'), $this->config->get($this->config->get('config_theme') . '_image_location_height'));
				} else {
					$image = false;
				}

				$data['locations'][] = array(
					'location_id' => $location_info['location_id'],
					'name'        => $location_info['name'],
					'address'     => nl2br($location_info['address']),
					'geocode'     => $location_info['geocode'],
					'telephone'   => $location_info['telephone'],
					'fax'         => $location_info['fax'],
					'image'       => $image,
					'open'        => nl2br($location_info['open']),
					'comment'     => $location_info['comment']
				);
			}
		}
        
//edit di sini
		if (isset($this->request->post['orderid'])) {
			$data['orderid'] = $this->request->post['orderid'];
		} else {
			$data['orderid'] = '';
		}

		if (isset($this->request->post['email'])) {
			$data['email'] = $this->request->post['email'];
		} else {
			$data['email'] = $this->customer->getEmail();
		}
        if (isset($this->request->post['rekening_asal'])) {
			$data['rekening_asal'] = $this->request->post['rekening_asal'];
		} else {
			$data['rekening_asal'] = '';
		}
        if (isset($this->request->post['atas_nama'])) {
			$data['atas_nama'] = $this->request->post['atas_nama'];
		} else {
			$data['atas_nama'] = '';
		}
        if (isset($this->request->post['rekening_tujuan'])) {
			$data['rekening_tujuan'] = $this->request->post['rekening_tujuan'];
		} else {
			$data['rekening_tujuan'] = '';
		}
        if (isset($this->request->post['jumlah_transfer'])) {
			$data['jumlah_transfer'] = $this->request->post['jumlah_transfer'];
		} else {
			$data['jumlah_transfer'] = '';
		}
        
        if (isset($this->request->post['bank'])) {
			$data['bank'] = $this->request->post['bank'];
		} else {
			$data['bank'] = '';
		}
        
        if (isset($this->request->post['date_added'])) {
      $data['date_added'] = $this->request->post['date_added'];
    } elseif (!empty($review_info)) {
      $data['date_added'] = $review_info['date_added'];
    } else {
      $data['date_added'] = date('Y-m-d');
    }
        
		

		// Captcha
		if ($this->config->get($this->config->get('config_captcha') . '_status') && in_array('contact', (array)$this->config->get('config_captcha_page'))) {
			$data['captcha'] = $this->load->controller('captcha/' . $this->config->get('config_captcha'), $this->error);
		} else {
			$data['captcha'] = '';
		}

		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');

		$this->response->setOutput($this->load->view('information/confirmation', $data));
	}

	protected function validate() {
		if ((utf8_strlen($this->request->post['orderid']) < 1) || (utf8_strlen($this->request->post['orderid']) > 32)) {
			$this->error['orderid'] = $this->language->get('error_orderid');
		}

		if (!filter_var($this->request->post['email'], FILTER_VALIDATE_EMAIL)) {
			$this->error['email'] = $this->language->get('error_email');
		}
        
        if ((utf8_strlen($this->request->post['rekening_asal']) < 3) || (utf8_strlen($this->request->post['rekening_asal']) > 32)) {
			$this->error['rekening_asal'] = $this->language->get('error_rekening_asal');
		}
        
        if ((utf8_strlen($this->request->post['atas_nama']) < 3) || (utf8_strlen($this->request->post['atas_nama']) > 32)) {
			$this->error['atas_nama'] = $this->language->get('error_atas_nama');
		}
        
        if ($this->request->post['rekening_tujuan']== ''){
			$this->error['rekening_tujuan'] = $this->language->get('error_rekening_tujuan');
		}
        
        if ((utf8_strlen($this->request->post['jumlah_transfer']) < 3) || (utf8_strlen($this->request->post['jumlah_transfer']) > 32)) {
			$this->error['jumlah_transfer'] = $this->language->get('error_jumlah_transfer');
		}


		// Captcha
		if ($this->config->get($this->config->get('config_captcha') . '_status') && in_array('contact', (array)$this->config->get('config_captcha_page'))) {
			$captcha = $this->load->controller('captcha/' . $this->config->get('config_captcha') . '/validate');

			if ($captcha) {
				$this->error['captcha'] = $captcha;
			}
		}

		return !$this->error;
	}

	public function success() {
		$this->load->language('information/confirmation');

		$this->document->setTitle($this->language->get('heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('information/confirmation')
		);

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_message'] = $this->language->get('text_success');

		$data['button_continue'] = $this->language->get('button_continue');

		$data['continue'] = $this->url->link('common/home');

		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');

		$this->response->setOutput($this->load->view('common/success', $data));
	}
}
